c     Version 2.0, Nov. 1, 1994.
      program gaussmaker
      implicit none
      double precision mass1,mass2,gammav,gamma,rapid,temp
      double precision pt1,pt2,rx,ry,rz,tau,lambda,b,bmin,bmax,delb
      double precision bw0,bcut,x,y,z,t,e,px,py,pz,znew,gauss
      integer*4 IDUM,IDUM2,IY,IV(32)
      common/RAN2JUNK/IDUM,IDUM2,IY,IV
      double precision ran2,randy
      integer ib,nb,i,ident,npts1,npts2,iseed
c     This program generates phase space points for use by 'cmain.f'
c     It generates gaussian distributions in time and space and thermal
c     distributions for the momenta. The phase space points are then
c     boosted along the z-axis according to the rapidity.  The user enters
c     the temperature, Rx,Ry,Rz and lifetime tau of the source.  All
c     variables correspond to the conv. g(x) = e{-x^2/(2*R**2)}...
c     The program will run much more efficiently for heavy particles,
c     (T << mass) if the gaussian routines are used rather than
c     the subroutine 'relpfind' for generating momenta which are relativistic
c     in the frame of the source.
c     The program will generate a fraction of the points, (1-dsqrt(lambda)),
c     such that correlationss would give a corresponding intercept of
c     1+lambda when doing pure Bose problems.
c     
c     I think it is easy to figure out the program without comments,
c     but then, I wrote them.  - Scott
c     --------- Usually you need to edit these lines appropriately ------
c     Make ident 0 if particles are not identical, 1 if they are identical
      ident=0
c     Choose the masses of the two particles
c      mass1=938.28d0
c      mass1=939.6d0
c     mass2=939.6d0
      mass1=139.58d0
c     mass2=493.646d0
c      mass1=1875.585d0
c      mass2=3727.323d0
      mass2=mass1
c     -----------------------------------------------------
      IDUM=-1234
c     Choose the number of impact parameters.  This is chosen different
c     than unity only for the purpose of testing the program.
      open(20,form='formatted',file='phasedescription.dat',
     +     status='unknown')
      open(21,form='formatted',file='phasespace1.dat',status='unknown')
      if(ident.eq.0) open(22,form='formatted',file='phasespace2.dat',
     +     status='unknown')
      nb=1
      write(20,*) nb
      write(6,*) 'what is the rapidity of the thermal source?'
      read(5,*) rapid
      gammav=sinh(rapid)
      gamma=cosh(rapid)
      write(6,*) 'what is the temperature?'
      read(5,*) temp
      pt1=dsqrt(mass1*temp)
      pt2=dsqrt(mass2*temp)
      write(6,*) 'what are rx,ry,rz and tau?'
      read(5,*) rx,ry,rz,tau
      write(6,*) 'what is lambda?'
      read(5,*) lambda
      lambda=dsqrt(lambda)
      delb=1.0
      do 111 ib=1,nb
         b=delb*(.5d0+dfloat(ib-1))
         bmin=b-.5d0*delb
         bmax=b+.5d0*delb
         if(nb.eq.1) b=0.d0
         npts1=10000
         npts2=10000
         bw0=1.d0
         bcut=1.d0
         write(20,*) b,bmin,bmax,npts1,npts2,bw0,bcut
         do 727 i=1,npts1
c     The next 3 lines are for non-rel mom. distributions.
            px=pt1*gauss()
            py=pt1*gauss()
            pz=pt1*gauss()
c     Use the next line for relativistic thermal distributions.
c     If the temp. is small (<<mass), the next routine becomes numerically 
c     inefficient and one should use the non-relativistic routine.
c     
c     call relpfind(px,py,pz,mass1,temp)
            e=dsqrt(mass1**2+px**2+py**2+pz**2)
            randy=ran2()
            if(randy.lt.lambda) then
               x=b+rx*gauss()
               y=ry*gauss()
               z=rz*gauss()
            else
               x=b+1000000.d0*gauss()
               y=1000000.d0*gauss()
               z=1000000.d0*gauss()
            endif
            t=tau*gauss()
            pz=gamma*pz+gammav*e
            znew=gamma*z+gammav*t
            t=gamma*t+gammav*z
            z=znew
            write(21,*) px,py,pz,x,y,z,t
 727     continue
         if (ident.eq.0) then
	    do 728 i=1,npts2
               px=pt2*gauss()
               py=pt2*gauss()
               pz=pt2*gauss()
c     call relpfind(px,py,pz,mass2,temp)
               e=dsqrt(mass2**2+px**2+py**2+pz**2)
               x=b+rx*gauss()
               y=ry*gauss()
               z=rz*gauss()
               t=tau*gauss()
               pz=gamma*pz+gammav*e
               znew=gamma*z+gammav*t
               t=gamma*t+gammav*z
               z=znew
               write(22,*) px,py,pz,x,y,z,t
 728        continue
         endif
 111  continue
      close(20)
      close(21)
      if(ident.eq.0) close(22)
      stop
      end
c     __________________________________________
c     
c
      subroutine relpfind(px,py,pz,mass,temp)
      implicit none
      double precision px,py,pz,mass,temp,e,randy,ran2
      double precision p,sth,cth,phi,w,arg,pi
      integer i,idummy
      pi=dacos(-1.d0)
 111  arg=ran2()*ran2()*ran2()
      if(arg.lt.0.0000001d0) go to 111
      p=-temp*dlog(arg)
      e=dsqrt(mass**2+p**2)
      w=dexp(-(e-p)/temp)
      randy=ran2()
      if(randy.gt.w) go to 111
      cth=1.d0-2.d0*ran2()
      sth=dsqrt(1.d0-cth**2)
      phi=2.d0*pi*ran2()
      pz=p*cth
      px=p*sth*dcos(phi)
      py=p*sth*dsin(phi)
      return
      end
c     This needs to go in the main program
c     integer*4 IDUM,IDUM2,IY,IV(32)
c     common/RAN2JUNK/IDUM,IDUM2,IY,IV
c     double precision ran2
c     
      double precision function ran2()
      implicit none
      integer IM1,IM2,IMM1,IA1,IA2,IQ1,IQ2,IR1,IR2,NTAB,NDIV
      real EPS,RNMX,AM
      parameter (IM1=2147483563,IM2=2147483399,IMM1=(IM1-1))
      parameter (IA1=40014,IA2=40692,IQ1=53668,IQ2=52774,IR1=12211)
      parameter (IR2=3791,NTAB=32,NDIV=(1+IMM1/NTAB))
      parameter (EPS=1.2e-7,RNMX=(1.0-EPS),AM=(1.0/IM1))
c
      integer*4 IDUM
      integer*4 J
      integer*4 K
      integer*4 IDUM2
      integer*4 IY
      integer*4 IV(0:NTAB-1)
      double precision TEMP
      common/RAN2JUNK/IDUM,IDUM2,IY,IV
c      write(6,*) 'IDUM=',IDUM
      if(IDUM.le.0) then
         IDUM2=123456789
         IY=0
         IDUM =-IDUM
         IDUM2=IDUM
         do J=NTAB+7,0,-1
            K=(IDUM)/IQ1
            IDUM=IA1*(IDUM-K*IQ1)-K*IR1
            if(IDUM.lt.0) IDUM =IDUM+IM1
            if(J.lt.NTAB) IV(J)=IDUM
         enddo
         IY=IV(0)
c         write(6,*) 'Initialization completed, IDUM=', IDUM
      endif
      K=(IDUM)/IQ1
      IDUM=IA1*(IDUM-K*IQ1)-K*IR1
      if(IDUM.lt.0) IDUM=IDUM+IM1
      K=IDUM2/IQ2
      IDUM2=IA2*(IDUM2-K*IQ2)-K*IR2
      if(IDUM2.lt.0) IDUM2=IDUM2+IM2
      J=IY/NDIV
      IY=IV(J)-IDUM2
      IV(J)=IDUM
      if(IY.lt.1) IY=IY+IMM1
      TEMP=AM*IY
      if(TEMP.gt.RNMX) then
         ran2=RNMX
      else
         ran2=TEMP
      endif
      return
      end
c
      double precision function gauss()
      implicit none
      double precision x,y,r2,r,c,ran2
 100  x=(1.d0-2.d0*ran2())
      y=(1.d0-2.d0*ran2())
      r2=x**2+y**2
      if(r2.gt.1.d0) go to 100
      r=dsqrt(r2)
      c=x/r
      gauss=c*dsqrt(-2.d0*dlog(r2))
      return
      end
